%def_with alsa
%def_without arts
%def_without newtranslations
%define qtdir %_libdir/qt3

Name: rosegarden
Version: 1.0
Release: alt1

Summary: MIDI and audio sequencer and musical notation editor
License: GPL
Group: Sound
Url: http://www.rosegardenmusic.com
Packager: Yuri N. Sedunov <aris@altlinux.ru>

Source: %name-4-%version.tar.bz2
Patch: %name-4-0.9.9-alt-makefile.patch
Patch1: kde_detect_automake-1.9.patch

# icons from MDK
Source1: %name-16.xpm
Source2: %name-32.xpm
Source3: %name-48.xpm

%if_with newtranslations
Source4: %name-0.9.9.ru.po
%endif

# Automatically added by buildreq on Sat Jul 31 2004 (-bi)
BuildRequires: XFree86-devel-static XFree86-libs dssi fontconfig-devel freetype2-devel gcc-c++ glib2 jackit-devel kde-settings kdelibs-devel ladspa_sdk libalsa-devel libjpeg-devel liblo-devel liblrdf-devel libmad-devel libpng-devel libqt3-devel libraptor-devel libstdc++-devel libtiff-devel pkgconfig python-base python-modules-compiler python-modules-encodings qt3-designer rpm-build-python xml-utils zlib-devel

%description
Rosegarden is a professional audio and MIDI sequencer, score editor, and
general-purpose music composition and editing environment.

Rosegarden is an easy-to-learn, attractive application that runs on
Linux, ideal for composers, musicians, music students, and small studio
or home recording environments. It is currently in a beta release phase,
in preparation for a full 1.0 release later in the year.

%package common
Summary: Common files for Rosegarden
Group: Sound

%description common
This package contains common files for Rosegarden

%package -n lib%name-alsa
Summary: Shared library for %name with ALSA support
Group: System/Libraries

%description -n lib%name-alsa
This package contains shared library required for %name-alsa to work.

%package -n lib%name-arts
Summary: Shared library for %name with aRts support
Group: System/Libraries

%description -n lib%name-arts
This package contains shared library required for %name-arts to work.

%package alsa
Summary: Rosegarden alsa version
Group: Sound
Requires: %name-common = %version-%release
Requires: lib%name-alsa = %version-%release
Requires: fluidsynth 

%description alsa
Rosegarden is a professional audio and MIDI sequencer, score editor, and
general-purpose music composition and editing environment.

Rosegarden is an easy-to-learn, attractive application that runs on
Linux, ideal for composers, musicians, music students, and small studio
or home recording environments. It is currently in a beta release phase,
in preparation for a full 1.0 release later in the year.
 
This package provides Rosegarden-4 compiled for ALSA with JACK. 

%package arts
Summary: Rosegarden-4 arts version
Group: Sound
Requires: %name-common = %version-%release
Requires: lib%name-arts = %version-%release

%description arts
Rosegarden is a professional audio and MIDI sequencer, score editor, and
general-purpose music composition and editing environment.

Rosegarden is an easy-to-learn, attractive application that runs on
Linux, ideal for composers, musicians, music students, and small studio
or home recording environments. It is currently in a beta release phase,
in preparation for a full 1.0 release later in the year.

This package provides Rosegarden-4 compiled for aRts. However the
ALSA/JACK combination is the preferred and better supported combination.

%define customdocdir %_docdir/%name-%version

## %customdocdir/task_lists/tasks_rwb.txt 
## does not recognized as a text file (/usr/bin/file bug)

# this does not work
#%add_verify_elf_skiplist %customdocdir/*/*

# try
%add_strip_skiplist %customdocdir/*/*

%prep
%setup -q -c -n %name-4-%version

pushd %name-4-%version
%patch -p1
%patch1 -p1

%if_with newtranslations
%__cp %SOURCE4 po/ru.po
%endif

%__subst 's,\.la\>,.so,' configure* admin/acinclude.m4*
%__subst 's,\"rosegardensequencer\",ROSEGARDEN_SEQUENCER_APP_NAME,' \
gui/rosegardengui.cpp sequencer/main.cpp
popd

# prepare docs
%__cp -r %name-4-%version/docs ./
%__cp %name-4-%version/{AUTHORS,ChangeLog,README,TODO} docs/
find docs -type f -name "Makefile*" -print0|xargs -r0 %__rm -f --
find docs -type d -empty -print0|xargs -r0 %__rm -rf --

# rename the unpacked %name directory to "alsa-build"
%__mv %name-4-%version alsa-build
# make a copy of this directory to "arts-buid"
%__cp -r alsa-build arts-build

pushd alsa-build
%__subst 's,\(ROSEGARDEN_SEQUENCER_APP_NAME .*rosegardensequencer\),\1-alsa,' gui/rosegardendcop.h
popd
pushd arts-build
%__subst 's,\(ROSEGARDEN_SEQUENCER_APP_NAME .*rosegardensequencer\),\1-arts,' gui/rosegardendcop.h
popd

%build
%define options --disable-rpath --with-qt-dir=%qtdir --with-ladspa

%if_with alsa
pushd alsa-build
%make -f admin/Makefile.common
    %configure \
    %options \
    --with-jack \
    --program-suffix=-alsa

%make_build SOUND_SUFFIX=-alsa
popd
%endif

%if_with arts
pushd arts-build
%make -f admin/Makefile.common
    %configure \
    %options \
    --with-arts \
    --program-suffix=-arts

%make_build SOUND_SUFFIX=-arts
popd
%endif

%install
%if_with alsa
%makeinstall -C alsa-build
%endif
%if_with arts
%makeinstall -C arts-build
%endif

# menus
%__mkdir_p %buildroot%_menudir
%__cat <<__MENU__ > %buildroot%_menudir/%name
?package(%name-common): needs="x11" section="Multimedia/Sound/" \
title="Rosegarden" \
longtitle="MIDI and audio sequencer and musical notation editor" \
icon="%name.xpm"
__MENU__

%if_with alsa
%__cat <<__MENU_ALSA__ > %buildroot%_menudir/%name-alsa
?package(%name-alsa): needs="x11" section="Multimedia/Sound/Rosegarden" \
title="Rosegarden-4-alsa" longtitle="Rosegarden-4-alsa" \
command="%_bindir/rosegarden-alsa" icon="%name.xpm"
?package(%name-alsa): needs="x11" section="Multimedia/Sound/Rosegarden" \
title="Rosegarden-4-alsa (nosequencer)" longtitle="Rosegarden-4-alsa (nosequencer)" \
command="%_bindir/rosegarden-alsa --nosequencer" icon="%name.xpm"
__MENU_ALSA__
%endif

%if_with arts
%__cat <<__MENU_ARTS__ > %buildroot%_menudir/%name-arts
?package(%name-arts): needs="x11" section="Multimedia/Sound/Rosegarden" \
title="Rosegarden-4-arts" longtitle="Rosegarden-4-arts" \
command="%_bindir/rosegarden-arts" icon="%name.xpm"
?package(%name-arts): needs="x11" section="Multimedia/Sound/Rosegarden" \
title="Rosegarden-4-arts (nosequencer)" longtitle="Rosegarden-4-arts (nosequencer)" \
command="%_bindir/rosegarden-arts --nosequencer" icon="%name.xpm"
__MENU_ARTS__
%endif

%__install -pD -m644 %SOURCE1 %buildroot%_miconsdir/%name.xpm
%__install -pD -m644 %SOURCE2 %buildroot%_iconsdir/%name.xpm
%__install -pD -m644 %SOURCE3 %buildroot%_liconsdir/%name.xpm

# docs
%__mkdir_p %buildroot%customdocdir
%__cp -r docs/* %buildroot%customdocdir/

# remove none-packaged files
%__rm -f %buildroot%_libdir/*.so
%__rm -rf %buildroot%_datadir/applnk

%find_lang --with-kde --output=%name.lang %name %{name}sequencer

%post common
%update_menus

%postun common
%clean_menus

%post -n lib%name-alsa -p %post_ldconfig
%postun -n lib%name-alsa -p %postun_ldconfig

%post -n lib%name-arts -p %post_ldconfig
%postun -n lib%name-arts -p %postun_ldconfig

%post alsa
%update_menus

%postun alsa
%clean_menus

%post arts
%update_menus

%postun arts
%clean_menus

%files common -f %name.lang
#%_datadir/applnk/*/*
%_datadir/apps/%name
%_datadir/mimelnk/*/*
%_iconsdir/*.xpm
%_iconsdir/*/*.xpm
%_iconsdir/*/*/*/*.xpm
%_iconsdir/*/*/*/*.png
%_menudir/%name
%customdocdir

%if_with alsa
%files -n lib%name-alsa
%_libdir/*-alsa.so.*
%endif

%if_with arts
%files -n lib%name-arts
%_libdir/*-arts.so.*
%endif

%if_with alsa
%files alsa
%_bindir/%name-alsa
%_bindir/%{name}sequencer-alsa
%_menudir/%name-alsa
%endif

%if_with arts
%files arts
%_bindir/%name-arts
%_bindir/%{name}sequencer-arts
%_menudir/%name-arts
%endif

%changelog
* Tue Feb 15 2005 Yuri N. Sedunov <aris@altlinux.ru> 1.0-alt1
- 1.0 release.

* Fri Jan 21 2005 Yuri N. Sedunov <aris@altlinux.ru> 0.9.91-alt0.95
- 1.0pre1.
- fixed build with latest automake-1.9.4.

* Thu Jul 29 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.9-alt0.9
- 0.9.9
- do not build impracticable aRts version.

* Sat May 29 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.8-alt0.5
- 0.9.8

* Fri Mar 26 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.7-alt0.5
- new version.

* Tue Jan 13 2004 Yuri N. Sedunov <aris@altlinux.ru> 0.9.6-alt0.5
- new version.

* Sat Nov 29 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.5-alt0.5
- new version.

* Sat Sep 27 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.1-alt0.6
- try rebuild with hasher.

* Fri Jun 06 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9.1-alt0.5
- 0.9.1

* Wed Apr 30 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.9-alt0.5
- 0.9

* Thu Mar 06 2003 Yuri N. Sedunov <aris@altlinux.ru> 0.8.5-alt0.5
- First build for Sisyphus.

